; Sat Jan 07 19:40:55 CET 2006
; 
;+ (version "2.1.2")
;+ (build "Build 246")


(defclass %3ACLIPS_TOP_LEVEL_SLOT_CLASS "Fake class to save top-level slot information"
	(is-a USER)
	(role abstract)
	(multislot manana
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(single-slot nombre
;+		(comment "El nombre de la actividad")
		(type STRING)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot comida_segunda
		(type INSTANCE)
;+		(allowed-classes Actividad_Comida)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot edad_m'axima
;+		(comment "La edad máxima recomendada")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot presupuesto
		(type SYMBOL)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot comida_primera
		(type INSTANCE)
;+		(allowed-classes Actividad_Comida)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot edad_m'inima
;+		(comment "La edad mínima recomendada o , depende de la actividad, la edad mínima según la ley.")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(multislot noche
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(single-slot precio
;+		(comment "El precío, más o menos, normalmente depende de la persona.")
		(type FLOAT)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot direcci'on
;+		(comment "La dirección de la actividad")
		(type STRING)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot duraci'on
;+		(comment "La duración recomendada de la actividad. El número de franjas.")
		(type INTEGER)
		(range 1 3)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot grupo
		(type SYMBOL)
		(allowed-values s'i no)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(multislot tarde
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(multislot franja
;+		(comment "La franja en que la actividad empieza.")
		(type SYMBOL)
		(allowed-values manana tarde noche)
		(cardinality 1 3)
		(create-accessor read-write))
	(single-slot edad
;+		(comment "La edad de la persona")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot hecho
;+		(comment "El estado de la actividad")
		(type SYMBOL)
		(allowed-values no s'i)
		(default no)
;+		(cardinality 0 1)
		(create-accessor read-write)))

(defclass Actividad
	(is-a USER)
	(role concrete)
	(multislot franja
;+		(comment "La franja en que la actividad empieza.")
		(type SYMBOL)
		(allowed-values manana tarde noche)
		(cardinality 1 3)
		(create-accessor read-write))
	(single-slot direcci'on
;+		(comment "La dirección de la actividad")
		(type STRING)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot edad_m'axima
;+		(comment "La edad máxima recomendada")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot duraci'on
;+		(comment "La duración recomendada de la actividad. El número de franjas.")
		(type INTEGER)
		(range 1 3)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot precio
;+		(comment "El precío, más o menos, normalmente depende de la persona.")
		(type FLOAT)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot edad_m'inima
;+		(comment "La edad mínima recomendada o , depende de la actividad, la edad mínima según la ley.")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot nombre
;+		(comment "El nombre de la actividad")
		(type STRING)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot grupo
		(type SYMBOL)
		(allowed-values s'i no)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot hecho
;+		(comment "El estado de la actividad")
		(type SYMBOL)
		(allowed-values no s'i)
		(default no)
;+		(cardinality 0 1)
		(create-accessor read-write)))

(defclass Actividad_no_comida
	(is-a Actividad)
	(role concrete))

(defclass L'udica
	(is-a Actividad_no_comida)
	(role concrete))

(defclass Bar "Un bar es un lugar para disfrutar y beber algo."
	(is-a L'udica)
	(role concrete))

(defclass Bar_Irland'es
	(is-a Bar)
	(role concrete))

(defclass Bar_para_Internacionales
	(is-a Bar)
	(role concrete))

(defclass Bar_de_Cocktails
	(is-a Bar)
	(role concrete))

(defclass Club
	(is-a L'udica)
	(role concrete))

(defclass Discoteca
	(is-a L'udica)
	(role concrete))

(defclass Cultural
	(is-a Actividad_no_comida)
	(role concrete))

(defclass Teatro
	(is-a Cultural)
	(role concrete))

(defclass Teatro_Cl'asico
	(is-a Teatro)
	(role concrete))

(defclass Improvisaci'on
	(is-a Teatro)
	(role concrete))

(defclass Teatro_Alternativo
	(is-a Teatro)
	(role concrete))

(defclass Museo
	(is-a Cultural)
	(role concrete))

(defclass Historia
	(is-a Museo)
	(role concrete))

(defclass Arte
	(is-a Museo)
	(role concrete))

(defclass Personas_C'elebres
	(is-a Museo)
	(role concrete))

(defclass Tecnolog'ia
	(is-a Museo)
	(role concrete))

(defclass Monumento
	(is-a Cultural)
	(role concrete))

(defclass Monumento_Religioso
	(is-a Monumento)
	(role concrete))

(defclass Edificio
	(is-a Monumento)
	(role concrete))

(defclass Escultura
	(is-a Monumento)
	(role concrete))

(defclass Cine
	(is-a Cultural)
	(role concrete))

(defclass Cine_Programa
	(is-a Cine)
	(role concrete))

(defclass Cine_Alternativo
	(is-a Cine)
	(role concrete))

(defclass Cine_Famoso
	(is-a Cine)
	(role concrete))

(defclass Cine_Original
	(is-a Cine)
	(role concrete))

(defclass Comercial
	(is-a Actividad_no_comida)
	(role concrete))

(defclass Gu'ia_de_la_Ciudad
	(is-a Comercial)
	(role concrete))

(defclass Parque_de_Atracci'on
	(is-a Comercial)
	(role concrete))

(defclass Viajes_a_fuera
	(is-a Comercial)
	(role concrete))

(defclass Actividad_Comida
	(is-a Actividad)
	(role concrete))

(defclass Comida_Espanola
	(is-a Actividad_Comida)
	(role concrete))

(defclass Bar_Espanol
	(is-a Bar Comida_Espanola)
	(role concrete))

(defclass Comida_China
	(is-a Actividad_Comida)
	(role concrete))

(defclass Comida_Mexicana
	(is-a Actividad_Comida)
	(role concrete))

(defclass Comida_Italiana
	(is-a Actividad_Comida)
	(role concrete))

(defclass Comida_Turca
	(is-a Actividad_Comida)
	(role concrete))

(defclass Comida_Japonesa
	(is-a Actividad_Comida)
	(role concrete))

(defclass Comida_R'apida
	(is-a Actividad_Comida)
	(role concrete))

(defclass Persona
	(is-a USER)
	(role concrete)
	(single-slot edad
;+		(comment "La edad de la persona")
		(type INTEGER)
		(range 1 99)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot presupuesto
		(type SYMBOL)
;+		(cardinality 0 1)
		(create-accessor read-write)))

(defclass Horario "El horario de las actividades"
	(is-a USER)
	(role concrete)
	(multislot tarde
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(multislot manana
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(multislot noche
		(type INSTANCE)
;+		(allowed-classes Actividad_no_comida)
		(cardinality 1 3)
		(create-accessor read-write))
	(single-slot comida_primera
		(type INSTANCE)
;+		(allowed-classes Actividad_Comida)
;+		(cardinality 0 1)
		(create-accessor read-write))
	(single-slot comida_segunda
		(type INSTANCE)
;+		(allowed-classes Actividad_Comida)
;+		(cardinality 0 1)
		(create-accessor read-write)))
(definstances instancias
; Sat Jan 07 19:40:55 CET 2006
; 
;+ (version "2.1.2")
;+ (build "Build 246")

([a0] of Teatro_Cl'asico
	(direcci'on "La Rambla")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 10)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Teatre Liceu")
	(precio 20.0))

([a1] of Escultura
	(direcci'on "Pl. del Portal de la Pau")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(hecho no)
	(nombre "Monument a Colom")
	(precio 0.0))

([a10] of Club
	(direcci'on "Carrer de Sant Pau 65")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bar Marsella")
	(precio 5.0))

([a11] of Club
	(direcci'on "Plaza del Funicular")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Mirablau")
	(precio 5.0))

([a12] of Discoteca
	(direcci'on "Passeig de Picasso 40")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Magic")
	(precio 5.0))

([a13] of Discoteca
	(direcci'on "Avinguda Marqu'es de l'Argentera 6")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Rep'ublica")
	(precio 5.0))

([a14] of Discoteca
	(direcci'on "Carrer Almog'avers 122")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Razzmatazz")
	(precio 5.0))

([a15] of Discoteca
	(direcci'on "Nou de la Rambla 113")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Sala Apolo")
	(precio 5.0))

([a16] of Discoteca
	(direcci'on "Tigre 27")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "La Paloma")
	(precio 10.0))

([a17] of Discoteca
	(direcci'on "Carrer Lincoln 15")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Otto Zutz")
	(precio 10.0))

([a18] of Discoteca
	(direcci'on "Viladomat 211")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Agua de Luna")
	(precio 5.0))

([a19] of Discoteca
	(direcci'on "Muntaner 246")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Luz de Gas")
	(precio 5.0))

([a2] of Club
	(direcci'on "Passeig del Born 19")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Pen'ultimo")
	(precio 5.0))

([a20] of Discoteca
	(direcci'on "Deu i Mata 105")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bikini")
	(precio 5.0))

([a21] of Discoteca
	(direcci'on "Carrer Tuset 13")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "The Sutton Club")
	(precio 5.0))

([a22] of Discoteca
	(direcci'on "Avinguda Marqu'es de Comillas")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Discoteca Torres de 'Avila")
	(precio 5.0))

([a23] of Comida_Espanola
	(direcci'on "Beltran i R'ozpide 1-5")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Neichel")
	(precio 70.0))

([a24] of Comida_Espanola
	(direcci'on "Carrer Tuset 27")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Reno")
	(precio 70.0))

([a26] of Comida_Espanola
	(direcci'on "Gran de Gr'acia")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Botafumeiro")
	(precio 70.0))

([a3] of Club
	(direcci'on "Passeig del Born 19")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "El Copet'in")
	(precio 5.0))

([a4] of Club
	(direcci'on "Passeig del Born 15")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Miramelindo")
	(precio 5.0))

([a5] of Club
	(direcci'on "Carrer del Rec 49")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Borneo")
	(precio 5.0))

([a6] of Club
	(direcci'on "Carrer Princesa 3")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Foro")
	(precio 5.0))

([a7] of Club
	(direcci'on "Nou de Sant Fransesc 7")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Dot Light Club")
	(precio 5.0))

([a8] of Club
	(direcci'on "Tallers 1")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Boadas")
	(precio 5.0))

([a9] of Club
	(direcci'on "Carrer de Santa M'onica 4")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 18)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Past'is")
	(precio 5.0))

([Actividades_Instance_0] of Cine_Famoso
	(direcci'on "Muelle d'Espanya")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Imax Port Vell")
	(precio 5.0))

([Actividades_Instance_1] of Cine_Famoso
	(direcci'on "Avenida Diagonal 3")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "AMC Cines Diagonal Mar")
	(precio 5.0))

([Actividades_Instance_10002] of Cine_Famoso
	(direcci'on "Calle Aribau 8-10")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Aribau")
	(precio 5.0))

([Actividades_Instance_10003] of Cine_Famoso
	(direcci'on "Rambla del Prat 16")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bosque")
	(precio 5.0))

([Actividades_Instance_10004] of Cine_Alternativo
	(direcci'on "Calle Salvador Espriu 61")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cines Icaria Yelmo Cineplex")
	(precio 6.0))

([Actividades_Instance_10005] of Cine_Famoso
	(direcci'on "Calle Sta  F'e de Nou M'exic")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cinesa Diagonal")
	(precio 6.0))

([Actividades_Instance_10006] of Cine_Famoso
	(direcci'on "Pasaje Andrey Nin")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cinesa Heron City")
	(precio 5.0))

([Actividades_Instance_10007] of Cine_Famoso
	(direcci'on "Calle Moll d'Espanya")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cinesa Maremagnum")
	(precio 6.0))

([Actividades_Instance_10008] of Cine_Programa
	(direcci'on "Calle Villarroel 102")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "M'eli'es Cinemes")
	(precio 4.0))

([Actividades_Instance_10009] of Teatro_Alternativo
	(direcci'on "Eixample")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Teatre T'ivoli")
	(precio 30.0))

([Actividades_Instance_10010] of Comida_China
	(direcci'on "Calle Conde Vilardaga 76")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Mas Lluhi")
	(precio 12.0))

([Actividades_Instance_10011] of Comida_China
	(direcci'on "Lincoln 17")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Memorias de china")
	(precio 40.0))

([Actividades_Instance_10012] of Comida_China
	(direcci'on "Avenida Diagonal 460")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Ming Dynasty")
	(precio 40.0))

([Actividades_Instance_10013] of Comida_China
	(direcci'on "Muntaner 100")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Out of china")
	(precio 30.0))

([Actividades_Instance_10014] of Comida_China
	(direcci'on "Passeig Andreu Nin 71")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho s'i)
	(nombre "Pato Laqueado")
	(precio 12.0))

([Actividades_Instance_10015] of Comida_China
	(direcci'on "Balmes 92")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Rio Azul")
	(precio 20.0))

([Actividades_Instance_10016] of Comida_China
	(direcci'on "Bisbe Sevilla 48")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Shanghai")
	(precio 40.0))

([Actividades_Instance_10017] of Comida_Mexicana
	(direcci'on "Sant Pere Martir 26")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Adelita Spring")
	(precio 20.0))

([Actividades_Instance_10018] of Comida_Mexicana
	(direcci'on "Torrijos 47-47bis")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cantina Machito")
	(precio 20.0))

([Actividades_Instance_10019] of Comida_Mexicana
	(direcci'on "Muntaner 92")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "El Chapul'in")
	(precio 20.0))

([Actividades_Instance_10020] of Comida_Mexicana
	(direcci'on "Torrijos 30")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Chido One")
	(precio 20.0))

([Actividades_Instance_10021] of Comida_Mexicana
	(direcci'on "Torrent de l'Olla 99")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "La Llorona")
	(precio 20.0))

([Actividades_Instance_10022] of Comida_Mexicana
	(direcci'on "Josep Anselm Clav'e")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Margarita Blue")
	(precio 20.0))

([Actividades_Instance_10023] of Comida_Mexicana
	(direcci'on "Reg'as 35")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "M'exico Lindo")
	(precio 30.0))

([Actividades_Instance_10024] of Comida_Italiana
	(direcci'on "PLaza Antonio Lopez 6")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Al Passatore")
	(precio 20.0))

([Actividades_Instance_10025] of Comida_Italiana
	(direcci'on "Ram'on Tr'ias Fragas 2-4")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bestial")
	(precio 40.0))

([Actividades_Instance_10026] of Comida_Italiana
	(direcci'on "Consell de Cent 333")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bice")
	(precio 30.0))

([Actividades_Instance_10027] of Comida_Espanola
	(direcci'on "Ganduxer 10-12")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Via Veneto")
	(precio 70.0))

([Actividades_Instance_10028] of Comida_Espanola
	(direcci'on "Argenteria 74-78")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Hofmann")
	(precio 70.0))

([Actividades_Instance_10029] of Comida_Espanola
	(direcci'on "Avinguda Diagonal 593")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Oliver y Hardy")
	(precio 50.0))

([Actividades_Instance_10030] of Comida_Espanola
	(direcci'on "Passeig Isabel II 14")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana noche tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Set Portes")
	(precio 50.0))

([Actividades_Instance_10031] of Comida_Espanola
	(direcci'on "Passeig Joan de Borb'o 70")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Can Costa")
	(precio 30.0))

([Actividades_Instance_10032] of Comida_R'apida
	(direcci'on "Plaza de Catalunya")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde manana)
	(grupo s'i)
	(hecho no)
	(nombre "Hard Rock Caf'e")
	(precio 30.0))

([Actividades_Instance_10033] of Comida_R'apida
	(direcci'on "Santal'o 155")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "La Compan'ia General de Sandwiches")
	(precio 8.0))

([Actividades_Instance_10034] of Comida_Espanola
	(direcci'on "Escudellers 14")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Los Caracoles")
	(precio 30.0))

([Actividades_Instance_10037] of Comida_Espanola
	(direcci'on "Plaza Reial")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Les Quinze Nits")
	(precio 30.0))

([Actividades_Instance_10038] of Comida_Espanola
	(direcci'on "Nou de la Rambla 101")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Restaurante 101")
	(precio 8.0))

([Actividades_Instance_10039] of Bar_Espanol
	(direcci'on "Plaza de Santa Maria 5")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "La Vinya del Senyor")
	(precio 20.0))

([Actividades_Instance_10040] of Bar_Espanol
	(direcci'on "Carrer Montcada 22")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Xampanyet")
	(precio 20.0))

([Actividades_Instance_10041] of Parque_de_Atracci'on
	(direcci'on "Tibidabo")
	(duraci'on 2)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Tibidabo")
	(precio 20.0))

([Actividades_Instance_10042] of Parque_de_Atracci'on
	(direcci'on "Serra de Collserola")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Parc del  Laberint d'Horta")
	(precio 5.0))

([Actividades_Instance_10043] of Tecnolog'ia
	(direcci'on "Carrer Roviralta 55")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 4)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu de la Ci'encia")
	(precio 5.0))

([Actividades_Instance_10044] of Tecnolog'ia
	(direcci'on "Montjuic")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Militar")
	(precio 5.0))

([Actividades_Instance_10045] of Historia
	(direcci'on "Carrer Aristides Maillol")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museo del Futbol Club Barcelona")
	(precio 10.0))

([Actividades_Instance_10046] of Arte
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu de la Xocolata")
	(precio 5.0))

([Actividades_Instance_10047] of Personas_C'elebres
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museo de Cera")
	(precio 5.0))

([Actividades_Instance_10048] of Arte
	(direcci'on "Plaza dels 'Angels 1")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu d'Art Contemporani")
	(precio 8.0))

([Actividades_Instance_10049] of Historia
	(direcci'on "Passeig Santa Madrona 39-41")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu d'Arqueologia de Catalunya")
	(precio 6.0))

([Actividades_Instance_10050] of Arte
	(direcci'on "Mirador del Palau Nacional")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Nacional d'Art de Catalunya")
	(precio 7.0))

([Actividades_Instance_10051] of Arte
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Barbier-Mueller d'Art Precolombi")
	(precio 7.0))

([Actividades_Instance_10052] of Arte
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Caixa Forum")
	(precio 8.0))

([Actividades_Instance_10053] of Arte
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Centre de Cultura Contempor'ania de Barcelona")
	(precio 6.0))

([Actividades_Instance_10054] of Personas_C'elebres
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Casa-Museu Gaud'i")
	(precio 4.0))

([Actividades_Instance_10055] of Personas_C'elebres
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Frederic M'ares")
	(precio 6.0))

([Actividades_Instance_10056] of Monumento_Religioso
	(direcci'on "Plaza Guadi")
	(duraci'on 1)
	(edad_m'axima 1)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Sagrada Familia")
	(precio 7.0))

([Actividades_Instance_10057] of Edificio
	(direcci'on "Passeig de Gr'acia 43")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Casa Batll'o")
	(precio 5.0))

([Actividades_Instance_10058] of Edificio
	(direcci'on "Passeig de Gr'acia 92")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Casa Mil'a")
	(precio 7.0))

([Actividades_Instance_10059] of Personas_C'elebres
	(direcci'on "Carrer Arag'o 255")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Fundaci'o Antoni T'apies")
	(precio 7.0))

([Actividades_Instance_10060] of Edificio
	(direcci'on "Carrer Carolines 24")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Casa Vicens")
	(precio 6.0))

([Actividades_Instance_10061] of Edificio
	(direcci'on "Carrer Sant Antoni Maria Claret")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Hospital de la Santa Creu i de Sant Pau")
	(precio 0.0))

([Actividades_Instance_10062] of Monumento_Religioso
	(direcci'on "Avinguda de la Catedral")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Catedral")
	(precio 5.0))

([Actividades_Instance_10063] of Viajes_a_fuera
	(direcci'on "Montserrat")
	(duraci'on 3)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Montserrat")
	(precio 30.0))

([Actividades_Instance_10064] of Arte
	(direcci'on "Carrer F 22")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu de la M'usica")
	(precio 5.0))

([Actividades_Instance_10065] of Historia
	(direcci'on "Carrer Valencia 284")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Egipci")
	(precio 7.0))

([Actividades_Instance_10066] of Historia
	(direcci'on "Passeig de Santa Madrona")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Etnol'ogic")
	(precio 6.0))

([Actividades_Instance_10067] of Arte
	(direcci'on "Plaza Sant Iu 5-6")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Frederic Mar'es")
	(precio 6.0))

([Actividades_Instance_10068] of Edificio
	(direcci'on "Montjuic")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Estadi Ol'impic")
	(precio 0.0))

([Actividades_Instance_10069] of Edificio
	(direcci'on "Carrer Sant Francesce de Paula 2")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Palau de la M'usica Catalana")
	(precio 0.0))

([Actividades_Instance_10070] of Edificio
	(direcci'on "Avinguda Diagonal")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Palau de Pedralbes")
	(precio 0.0))

([Actividades_Instance_10071] of Edificio
	(direcci'on "Carrer Olot")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Parc Guell")
	(precio 0.0))

([Actividades_Instance_10072] of Edificio
	(direcci'on "Plaza Reial")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Plaza Reial")
	(precio 0.0))

([Actividades_Instance_10073] of Edificio
	(direcci'on "Avinguda Marqu'es de Comillas")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Poble Espanyol")
	(precio 0.0))

([Actividades_Instance_10074] of Edificio
	(direcci'on "Port Ol'impic")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Port Ol'impic")
	(precio 0.0))

([Actividades_Instance_10075] of Monumento_Religioso
	(direcci'on "Carrer Rivadeneyra")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Santa Anna")
	(precio 0.0))

([Actividades_Instance_10076] of Monumento_Religioso
	(direcci'on "Plaza Montcada")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Santa Maria del Mar")
	(precio 0.0))

([Actividades_Instance_10077] of Teatro_Cl'asico
	(direcci'on "Plaza de les Arts")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 12)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Teatre Nacional")
	(precio 10.0))

([Actividades_Instance_10078] of Monumento_Religioso
	(direcci'on "Tibidabo")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Sagrat Cor")
	(precio 0.0))

([Actividades_Instance_10079] of Edificio
	(direcci'on "Gran Via")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Universidad")
	(precio 0.0))

([Actividades_Instance_10080] of Parque_de_Atracci'on
	(direcci'on "Parc de la Ciutadella")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Parque de Zool'ogica^")
	(precio 7.0))

([Actividades_Instance_10081] of Teatro_Alternativo
	(direcci'on "Lleida 59")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 12)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Mercat de les Flors")
	(precio 7.0))

([Actividades_Instance_10082] of Teatro_Cl'asico
	(direcci'on "Carrer Sant Francesce de Paula 2")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 8)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Palau de la M'usica Catalana")
	(precio 12.0))

([Actividades_Instance_10083] of Teatro_Cl'asico
	(direcci'on "Plaza de les Arts")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 8)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Auditori")
	(precio 15.0))

([Actividades_Instance_10084] of Teatro_Alternativo
	(direcci'on "Passeig de Santa Madrona")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 12)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Teatre Grec")
	(precio 10.0))

([Actividades_Instance_10085] of Improvisaci'on
	(direcci'on "Carrer Montseny 47")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 10)
	(franja noche)
	(grupo s'i)
	(hecho no)
	(nombre "Teatre de Lliure")
	(precio 15.0))

([Actividades_Instance_2] of Personas_C'elebres
	(direcci'on "C/ de Montcada")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 10)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museo Picasso")
	(precio 4.0))

([Actividades_Instance_20027] of Comida_Italiana
	(direcci'on "Ample 20")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Boga")
	(precio 20.0))

([Actividades_Instance_20028] of Comida_Italiana
	(direcci'on "Plaza del Cap de la Vila")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cap de la Vila")
	(precio 30.0))

([Actividades_Instance_20029] of Comida_Italiana
	(direcci'on "Les Caputxes 4")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Caputxes")
	(precio 20.0))

([Actividades_Instance_20030] of Comida_Italiana
	(direcci'on "L'escar 10-16")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Restaurante Oblo")
	(precio 20.0))

([Actividades_Instance_20031] of Comida_R'apida
	(direcci'on "Plaza Pa'isos Catalans")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Mc Donalds")
	(precio 8.0))

([Actividades_Instance_20032] of Comida_R'apida
	(direcci'on "Mol de Barcelona 18")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Fast and Ready")
	(precio 10.0))

([Actividades_Instance_20033] of Comida_R'apida
	(direcci'on "Passeig del Born")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Sandwich % Friends")
	(precio 8.0))

([Actividades_Instance_20034] of Comida_R'apida
	(direcci'on "Canuda 25")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "The Bagel Shop")
	(precio 8.0))

([Actividades_Instance_20035] of Comida_R'apida
	(direcci'on "Avenida Diagonal 208")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Burger King")
	(precio 8.0))

([Actividades_Instance_20036] of Comida_Japonesa
	(direcci'on "Pasaje lluis Pellicer 20")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bun Sichi")
	(precio 40.0))

([Actividades_Instance_20037] of Comida_Japonesa
	(direcci'on "Diputaci'o")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Can Jap'o")
	(precio 40.0))

([Actividades_Instance_20038] of Comida_Japonesa
	(direcci'on "Passeo de Gr'acia")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cho")
	(precio 30.0))

([Actividades_Instance_20039] of Comida_Japonesa
	(direcci'on "Ronda Generak Mitre 136")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Edo")
	(precio 20.0))

([Actividades_Instance_20040] of Comida_Japonesa
	(direcci'on "Balmes 203")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Fuji")
	(precio 30.0))

([Actividades_Instance_20041] of Comida_Japonesa
	(direcci'on "Arag'o 277")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "La Gramola")
	(precio 20.0))

([Actividades_Instance_20042] of Comida_Japonesa
	(direcci'on "Balmes 55")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Hanabisi")
	(precio 30.0))

([Actividades_Instance_20043] of Bar_Espanol
	(direcci'on "Joaquim Costa 61")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "'Acido 'Oxido")
	(precio 5.0))

([Actividades_Instance_20044] of Bar_Espanol
	(direcci'on "Joaquin Costa 33")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Almirall")
	(precio 5.0))

([Actividades_Instance_20045] of Bar_para_Internacionales
	(direcci'on "Sant Pau 77")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Ambar")
	(precio 6.0))

([Actividades_Instance_20046] of Bar_Espanol
	(direcci'on "Verdaguer i Call'is 12")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bar Antic Teatre")
	(precio 6.0))

([Actividades_Instance_20047] of Bar_Espanol
	(direcci'on "Arag'o 141")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Antilla")
	(precio 6.0))

([Actividades_Instance_20048] of Bar_Espanol
	(direcci'on "Calle del Nil 11")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Arcoiris")
	(precio 6.0))

([Actividades_Instance_20049] of Bar_Irland'es
	(direcci'on "Casanova 264")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Flann O'Brien")
	(precio 10.0))

([Actividades_Instance_20050] of Bar_Irland'es
	(direcci'on "Moll mestral 26-27")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Kennedy's")
	(precio 10.0))

([Actividades_Instance_20051] of Bar_Irland'es
	(direcci'on "Plaza Joaquim Xirau")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Paddy Flaherty's")
	(precio 10.0))

([Actividades_Instance_20052] of Bar_Irland'es
	(direcci'on "Ample 28")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde manana)
	(grupo s'i)
	(hecho no)
	(nombre "Ryan's")
	(precio 10.0))

([Actividades_Instance_20053] of Bar_Irland'es
	(direcci'on "Ronda Universitat 8")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Scobies")
	(precio 10.0))

([Actividades_Instance_20054] of Bar_Irland'es
	(direcci'on "Passeig Joan de Borb'o 22")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "The Fastnet")
	(precio 10.0))

([Actividades_Instance_20055] of Bar_Irland'es
	(direcci'on "Marqu'es de Barber'a")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde manana)
	(grupo s'i)
	(hecho no)
	(nombre "The Quiet Man")
	(precio 10.0))

([Actividades_Instance_20056] of Bar_de_Cocktails
	(direcci'on "Val'encia 191")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Blank")
	(precio 15.0))

([Actividades_Instance_20057] of Bar_de_Cocktails
	(direcci'on "Tallers 1")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Bodas")
	(precio 15.0))

([Actividades_Instance_20058] of Bar_de_Cocktails
	(direcci'on "Aribau 162-166")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Dry Martini")
	(precio 15.0))

([Actividades_Instance_20059] of Bar_de_Cocktails
	(direcci'on "Pau Claris 150")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "East 47"))

([Actividades_Instance_20060] of Bar_de_Cocktails
	(direcci'on "Roger de Ll'uria 40")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Forty"))

([Actividades_Instance_20061] of Bar_de_Cocktails
	(direcci'on "Palma de Sant Just 1")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 16)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Ginger")
	(precio 15.0))

([Actividades_Instance_20062] of Cine_Original
	(direcci'on "Calle Verdi 100")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde noche)
	(grupo s'i)
	(hecho no)
	(nombre "Cine Verdi")
	(precio 6.0))

([Actividades_Instance_3] of Tecnolog'ia
	(direcci'on "Av. de les Drassanes")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Museu Maritim")
	(precio 4.0))

([Actividades_Instance_4] of Personas_C'elebres
	(direcci'on "Av Miramar")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 5)
	(franja tarde)
	(grupo s'i)
	(hecho no)
	(nombre "Fundaci'o Joan Mir'o")
	(precio 7.0))

([Actividades_Instance_5] of Historia
	(direcci'on "Carrer del Verguer")
	(duraci'on 1)
	(edad_m'axima 99)
	(edad_m'inima 1)
	(franja manana)
	(grupo s'i)
	(hecho no)
	(nombre "Museo de Historia de la Ciudad")
	(precio 4.0))
)
(defglobal MAIN 
    ?*manana* = (create$)
    ?*tarde*  = (create$)
    ?*noche*  = (create$)
)

(defclass MAIN::Horario "El horario de las actividades"
   (is-a USER)
   (role concrete)
   (multislot noche
      (type INSTANCE)
      (cardinality 1 3)
      (create-accessor read-write))
   (single-slot comida_primera
      (type INSTANCE)
      (create-accessor read-write))
   (multislot tarde
      (type INSTANCE)
      (cardinality 1 3)
      (create-accessor read-write))
   (multislot manana
      (type INSTANCE)
      (cardinality 1 3)
      (create-accessor read-write))
   (single-slot comida_segunda
      (type INSTANCE)
      (create-accessor read-write)))

;;; ########################################################################
;;; ### Reglas, funciones, etc. para imprimir la planificaci'on          ###
;;; ########################################################################


;; La función "imprime-poco" imprime sólo el nombre y la dirección de una 
;; actividad. Usamos para monstrar la planificaión en la pantalla

(deffunction MAIN::imprime-poco
   (?v)
   (if (eq (nth$ 1 ?v) [nil]) then 
      (printout t "¡ ERROR !  0 actividades" crlf) (return)
   )
   (if (> (length$ ?v) 0)
      then
      (loop-for-count (?i 1 (length ?v))
         (printout t "nombre: " (send (nth$ ?i ?v ) get-nombre) crlf)
         (printout t "direcci'on: " (send (nth$ ?i ?v ) get-direcci'on) crlf)
         (printout t crlf)
      )))

;; Esta función hace la misma como "imprime-poco" pero hay una diferencia: 
;; en cada atributo hay sólo una actividad, no es multivaluado.

(deffunction MAIN::imprime-comida
   (?v)
   (if (eq ?v [nil]) then 
      (printout t "¡ ERROR !  0 actividades" crlf) (return)
   )
   (printout t "nombre: " (send ?v get-nombre) crlf)
   (printout t "direcci'on: " (send ?v get-direcci'on) crlf)
   (printout t crlf)
)

(deffunction MAIN::imprime-poco-comida
    (?v)
    (if (eq ?v [nil]) then 
       (printout t "¡ ERROR !  0 actividades" crlf) (return)
    )
    (printout t (send ?v get-nombre) crlf)
)
   
;; Para imprimir el horario con un message-handler. Se ejecuta cuando se 
;; escribe (send [instancia de horario] imprime)

(deffunction imprime-muy-poco
   (?v)
   (if (eq (nth$ 1 ?v) [nil]) then
      (printout t "¡ ERROR !  0 actividades" crlf) (return)
   )
   (if (> (length$ ?v) 0)
      then
      (loop-for-count (?i 1 (length ?v))
          (printout t (send (nth$ ?i ?v ) get-nombre) " ; ")
   ))
   (printout t crlf))

(defmessage-handler MAIN::Horario imprime primary
   ()

   (printout t "Manana:  ")
   (imprime-muy-poco ?self:manana)
   (printout t "Tarde :  ")
   (imprime-muy-poco ?self:tarde)
   (printout t "Noche :  ")
   (imprime-muy-poco ?self:noche)
   (printout t "Comida primera: ")
   (imprime-poco-comida ?self:comida_primera)
   (printout t "Comida segunda: ")
   (imprime-poco-comida ?self:comida_segunda)
)
		
;; Esta regla ejecutamos al final para imprimir todos los días de la
;; planificación recomendada

(defrule imprimir-planificaci'on
   (declare  (salience -30))
   (d'ia ?d)
=>
   (loop-for-count (?i 1 ?d)
      (printout t "D'ia " ?i ": " crlf)
      (send 
         (symbol-to-instance-name (string-to-field (str-cat "d" ?i))) imprime
      )
      (printout t crlf)
   ))

;;; ########################################################################
;;; ### Obtiene una respuesta de entre un conjunto de respuestas posibles###
;;; ########################################################################

	(deffunction pregunta (?pregunta $?valores_posibles)
   (printout t ?pregunta)
   (bind ?respuesta (read))
   (while (not (member ?respuesta ?valores_posibles)) do
      (printout t ?pregunta)
      (bind ?respuesta (read))
   )
   ?respuesta)

;;; ########################################################################
;;; ### Hace una pregunta a la que hay que responder si o no             ###
;;; ########################################################################

(deffunction si-o-no-p (?pregunta)
   (bind ?respuesta (pregunta ?pregunta si no s n))
   (if (or (eq ?respuesta si) (eq ?respuesta s))
       then TRUE 
       else FALSE))

;;; ########################################################################
;;; ### Hace una pregunta a la que hay que responder si, no, obl o proh  ###
;;; ########################################################################

(deffunction todo-pos-p (?pregunta)
   (bind ?respuesta (pregunta ?pregunta si no s n obligatorio prohibido o p))
   (switch ?respuesta
      (case si then s)
      (case s then s)
      (case no then n)
      (case n then n)
      (case obligatorio then o)
      (case o then o)
      (case prohibido then p)
      (case p then p)
      (default none))
)

;;; ########################################################################
;;; ### Las preguntas                                                    ###
;;; ########################################################################

(defrule determinar-tipo
  (declare (salience 10))
=>
  (if (si-o-no-p "¿Quieres un viaje tranquilo? (s/n) ") then
      (assert (tranquilo))
   else
      (assert (no tranquilo)))
  (if (si-o-no-p "¿Quieres visitar los lugares típicos de Barcelona? (s/n) ") 
   then (assert (local))
   else 
      (assert (no local)))
)

;;; ########################################################################
;;; ### Preguntas para el tipo del cine                                  ###
;;; ########################################################################

(defrule preg-cine
 ; ()
=>
  (if (si-o-no-p "¿Quieres opinar sobre cines? (s/n) ")
       then (assert (cine))
  )
)

(defrule preg-cine-original
  (cine)
  (no local)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el cine original? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Cine_Original)))
         (case o then (assert (obligatorio Cine_Original)))
         (case p then (assert (prohibido Cine_Original)))
      )
)

(defrule preg-cine-famoso
  (cine)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el cine famoso? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Cine_Famoso)))
         (case o then (assert (obligatorio Cine_Famoso)))
         (case p then (assert (prohibido Cine_Famoso)))
      )
)

(defrule preg-cine-alternativo
  (cine)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el cine alternativo? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Cine_Alternativo)))
         (case o then (assert (obligatorio Cine_Alternativo)))
         (case p then (assert (prohibido Cine_Alternativo)))
      )
)

;;; ########################################################################
;;; ### Preguntas para el tipo del teatro                                ###
;;; ########################################################################

(defrule preg-teatro
  (tranquilo)
=>
  (if (si-o-no-p "¿Quieres opinar sobre teatro? (s/n) ")
       then (assert (teatro))
  )
)

(defrule preg-teatro-cl'asico
  (teatro)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el teatro clásico? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Teatro_Cl'asico)))
         (case o then (assert (obligatorio Teatro_Cl'asico)))
         (case p then (assert (prohibido Teatro_Cl'asico)))
      )
)

(defrule preg-teatro-improvisaci'on
  (teatro)
=>
  (bind ?respuesta 
      (todo-pos-p "¿Te gusta el teatro improvisación? (s/n/o/p) ")
  )
      (switch ?respuesta
         (case s then (assert (gusta Improvisaci'on)))
         (case o then (assert (obligatorio Improvisaci'on)))
         (case p then (assert (prohibido Improvisaci'on)))
      )
)

(defrule preg-teatro-alternativo
  (teatro)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el teatro alternativo? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Teatro_Alternativo)))
         (case o then (assert (obligatorio Teatro_Alternativo)))
         (case p then (assert (prohibido Teatro_Alternativo)))
      )
)

;;; ########################################################################
;;; ### Preguntas para el tipo del museo                                 ###
;;; ########################################################################

(defrule preg-museo
  (tranquilo)
  (local)
=>
  (if (si-o-no-p "¿Quieres opinar sobre los museos? (s/n) ")
       then (assert (museo))
  )
)

(defrule preg-museo-historia
  (museo)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el museo historia? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Historia)))
         (case o then (assert (obligatorio Historia)))
         (case p then (assert (prohibido Historia)))
      )
)

(defrule preg-museo-arte
  (museo)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el museo de arte? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Arte)))
         (case o then (assert (obligatorio Arte)))
         (case p then (assert (prohibido Arte)))
      )
)

(defrule preg-museo-tecnolog'ia
  (museo)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta el museo de tecnología? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta Tecnolog'ia)))
         (case o then (assert (obligatorio Tecnolog'ia)))
         (case p then (assert (prohibido Tecnolog'ia)))
      )
)

(defrule preg-museo-personas-c'elebres
  (museo)
=>
  (bind ?respuesta 
      (todo-pos-p "¿Te gusta el museo de personas célebres? (s/n/o/p) ")
  )
  (switch ?respuesta
      (case s then (assert (gusta Personas_C'elebres)))
      (case o then (assert (obligatorio Personas_C'elebres)))
      (case p then (assert (prohibido Personas_C'elebres)))
  )
)

;;; ########################################################################
;;; ### Preguntas para el tipo del monumento                             ###
;;; ########################################################################

(defrule preg-monumento
  (tranquilo)
  (local)
=>
  (if (si-o-no-p "¿Quieres opinar sobre los monumentos? (s/n) ")
       then (assert (monumento))
  )
)

(defrule preg-monumento-edificio
  (monumento)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta edificios típicos? (s/n/o/p) "))
  (switch ?respuesta
      (case s then (assert (gusta Edificio)))
      (case o then (assert (obligatorio Edificio)))
      (case p then (assert (prohibido Edificio)))
   )
)

(defrule preg-monumento-religioso
  (monumento)
=>
  (bind ?respuesta 
      (todo-pos-p "¿Te gusta los monumentos religiosos? (s/n/o/p) ")
  )
  (switch ?respuesta
      (case s then (assert (gusta Monumento_Religioso)))
      (case o then (assert (obligatorio Monumento_Religioso)))
      (case p then (assert (prohibido Monumento_Religioso)))
  )
)

(defrule preg-monumento-escultura
  (monumento)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta las esculturas? (s/n/o/p) "))
   (switch ?respuesta
      (case s then (assert (gusta Escultura)))
      (case o then (assert (obligatorio Escultura)))
      (case p then (assert (prohibido Escultura)))
   )
)

;;; ########################################################################
;;; ### Preguntas para el tipo del bar                                   ###
;;; ########################################################################

(defrule preg-bar
  
=>
  (if (si-o-no-p "¿Te gustan los bares? (s/n) ")
       then (assert (bar))
  )
)

(defrule bar-espanol
  (bar)
  (local)
=>
  (assert (gusta Bar_Espanol))
)

(defrule preg-bar-espanol
  (bar)
  (no local)
=>
  (bind ?respuesta (todo-pos-p "¿Te gustan los bares españoles? (s/n/o/p) "))
  (switch ?respuesta
     (case s then (assert (gusta Bar_Espanol)))
     (case o then (assert (obligatorio Bar_Espanol)))
     (case p then (assert (prohibido Bar_Espanol)))
  )
)

(defrule preg-bar-irland'es
  (bar)
  (no local)
=>
  (bind ?respuesta (todo-pos-p "¿Te gustan los bares irlandeses? (s/n/o/p) "))
  (switch ?respuesta
     (case s then (assert (gusta Bar_Irland'es)))
     (case o then (assert (obligatorio Bar_Irland'es)))
     (case p then (assert (prohibido Bar_Irland'es)))
  )
)

(defrule preg-bar-internacional
  (bar)
  (no local)
=>
  (bind ?respuesta 
     (todo-pos-p "¿Te gustan los bares para internacionales? (s/n/o/p) ")
  )
  (switch ?respuesta
     (case s then (assert (gusta Bar_para_Internacionales)))
     (case o then (assert (obligatorio Bar_para_Internacionales)))
     (case p then (assert (prohibido Bar_para_Internacionales)))
  )
)

(defrule preg-bar-cocktail
  (bar)
  (no local)
=>
  (bind ?respuesta 
      (todo-pos-p "¿Te gustan los bares de cocktails? (s/n/o/p) ")
  )
  (switch ?respuesta
     (case s then (assert (gusta Bar_de_Cocktails)))
     (case o then (assert (obligatorio Bar_de_Cocktails)))
     (case p then (assert (prohibido Bar_de_Cocktails)))
  )
)

;;; ########################################################################
;;; ### Preguntas para el tipo de la actividad comercial                 ###
;;; ########################################################################

(defrule preg-comercial
  (no tranquilo)
=>
  (if (si-o-no-p "¿Quieres opinar sobre las actividades 
                                         organizadas y comerciales? (s/n) ")
       then (assert (comercial))
  )
)

(defrule preg-comercial-viaje_a_fuera
  (comercial)
  (local)
=>
  (bind ?respuesta (todo-pos-p "¿Te gustan los viajes a fuera? (s/n/o/p) "))
  (switch ?respuesta
     (case s then (assert (gusta Viajes_a_fuera)))
     (case o then (assert (obligatorio Viajes_a_fuera)))
     (case p then (assert (prohibido Viajes_a_fuera)))
  )
)

(defrule preg-comercial-gu'ia_de_la_ciudad
  (comercial)
  (local)
=>
  (bind ?respuesta 
      (todo-pos-p "¿Te gustan las guías de la ciudad? (s/n/o/p) ")
  )
  (switch ?respuesta
     (case s then (assert (gusta Gu'ia_de_la_Ciudad)))
     (case o then (assert (obligatorio Gu'ia_de_la_Ciudad)))
     (case p then (assert (prohibido Gu'ia_de_la_Ciudad)))
  )
)

(defrule preg-comercial-parque_de_atracci'on
  (comercial)
=>
  (bind ?respuesta 
     (todo-pos-p "¿Te gustan las parques de atracciones? (s/n/o/p) ")
  )
  (switch ?respuesta
     (case s then (assert (gusta Parque_de_Atracci'on)))
     (case o then (assert (obligatorio Parque_de_Atracci'on)))
     (case p then (assert (prohibido Parque_de_Atracci'on)))
  )
)

;;; ########################################################################
;;; ### Preguntas sobre dicotecas y clubs                                ###
;;; ########################################################################

(defrule preg-discoteca
  (no tranquilo)
=>
  (bind ?respuesta (todo-pos-p "¿Te gustan las discotecas? (s/n/o/p) "))
  (switch ?respuesta
     (case s then (assert (gusta Discoteca)))
     (case o then (assert (obligatorio Discoteca)))
     (case p then (assert (prohibido Discoteca)))
  )
)

(defrule preg-club
  (no tranquilo)
=>
  (bind ?respuesta (todo-pos-p "¿Te gustan los clubs? (s/n/o/p) "))
  (switch ?respuesta
     (case s then (assert (gusta Club)))
     (case o then (assert (obligatorio Club)))
     (case p then (assert (prohibido Club)))
  )
)

;;; ########################################################################
;;; ### Preguntas para el tipo de comida                                 ###
;;; ########################################################################

(defrule preg-preferencia-comida
=>
  (if (si-o-no-p "¿Tienes alguna preferencia de la comida? (s/n) ") then
     (assert (comida))
   else
     (assert (gusta comida Comida_R'apida))
     (assert (gusta comida Comida_Turca))
     (assert (gusta comida Comida_Japonesa))
     (assert (gusta comida Comida_Mexicana))
     (assert (gusta comida Comida_China))
     (assert (gusta comida Comida_Italiana))
     (assert (gusta comida Comida_Espanola))
  )
)

(defrule preg-lugar-comida
  (comida)
=>
  (if (si-o-no-p "¿Prefieres un bar para comer? (s/n) ") then
     (assert (gusta comida Comida_Espanola))
   else
     (assert (lugar_igual))
  )
)

(defrule preg-comida-r'apida
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida rápida? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_R'apida)))
         (case o then (assert (obligatorio comida Comida_R'apida)))
         (case p then (assert (prohibido comida Comida_R'apida)))
      )
)

(defrule preg-comida-turca
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida turca? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_Turca)))
         (case o then (assert (obligatorio comida Comida_Turca)))
         (case p then (assert (prohibido comida Comida_Turca)))
      )
)

(defrule preg-comida-japonesa
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida japonesa? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_Japonesa)))
         (case o then (assert (obligatorio comida Comida_Japonesa)))
         (case p then (assert (prohibido comida Comida_Japonesa)))
      )
)

(defrule preg-comida-mexicana
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida mexicana? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_Mexicana)))
         (case o then (assert (obligatorio comida Comida_Mexicana)))
         (case p then (assert (prohibido comida Comida_Mexicana)))
      )
)

(defrule preg-comida-china
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida china? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_China)))
         (case o then (assert (obligatorio comida Comida_China)))
         (case p then (assert (prohibido comida Comida_China)))
      )
)

(defrule preg-comida-italiana
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida italiana? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusto comida Comida_Italiana)))
         (case o then (assert (obligatorio comida Comida_Italiana)))
         (case p then (assert (prohibido comida Comida_Italiana)))
      )
)

(defrule preg-comida-espanola
  (lugar_igual)
=>
  (bind ?respuesta (todo-pos-p "¿Te gusta la comida española? (s/n/o/p) "))
      (switch ?respuesta
         (case s then (assert (gusta comida Comida_Espanola)))
         (case o then (assert (obligatorio comida Comida_Espanola)))
         (case p then (assert (prohibido comida Comida_Espanola)))
      )
)

;;; ########################################################################
;;; ### Preguntas comunes                                                ###
;;; ########################################################################

(defrule preg-precio
=>
  (if (si-o-no-p "¿Te importa el precio? (s/n) ")
     then (assert (precio_m'aximo 20))
   else
     (assert (precio_m'aximo 100))
  )
)

(defrule preg-grupo
=>
  (if (si-o-no-p "¿Viajas sólo? (s/n) ")
     then (assert (grupo no))
   else
     (assert (grupo s'i))
  )
)

(defrule preg-edad-solo
  (grupo no)
=>
  (printout t "¿Cuántos años tienes?")
  (bind ?respuesta (read))
  (while (not (integerp ?respuesta))
      (printout t "¿Cuántos años tienes?")
      (bind ?respuesta (read))
  )
  (assert (edad_m'inima ?respuesta))
  (assert (edad_m'axima ?respuesta))
)

(defrule preg-edad-grupo
  (grupo s'i)
=>
  (printout t "¿Cuántos años tiene la persona más joven?")
  (bind ?respuesta (read))
  (while (not (integerp ?respuesta))
      (printout t "¿Cuántos años tiene la persona más joven?")
      (bind ?respuesta (read))
  )
  (assert (edad_m'inima ?respuesta))
  (printout t "¿Cuántos años tiene la persona más mayor?")
  (bind ?respuesta (read))
  (while (not (integerp ?respuesta))
      (printout t "¿Cuántos años tiene la persona más mayor?")
      (bind ?respuesta (read))
  )
  (assert (edad_m'axima ?respuesta))
)

(defrule preg-duraci'on
=>
  (bind ?respuesta 
     (pregunta 
         "¿Cuántas franjas puede durar una actividad como máximo? (1/2/3) " 
      1 2 3)
  )
  (assert (duraci'on ?respuesta))
)

(defrule preg-cantidad-dia
=>
  (printout t "¿Cuántos días quieres quedar in Barcelona?")
  (bind ?respuesta (read))
  (while (not (integerp ?respuesta))
      (printout t "¿Cuántos días quieres quedar in Barcelona?")
      (bind ?respuesta (read))
  )
  (assert (d'ia ?respuesta))
)

;;; ########################################################################
;;; ### Crear las instancias del horario                                 ###
;;; ########################################################################

;; Esta regla solamente crea las instancias del horario después de la última
;; pregunta 

(defrule crear-horario
   (d'ia ?d)
=>
   (while (> ?d 0)
      (make-instance (string-to-field (str-cat "d" ?d)) of Horario)
      (bind ?d (- ?d 1))
   )
)

;;; ########################################################################
;;; ### Funciones para simplificar la programación                       ###
;;; ########################################################################

;; Una función para añadir una actividad a un atributo en que ya están
;; actividades puestas. Primero se recibe el contenido de un atributo, se
;; crea un valor multivaluado de las informaciones del atributo y de la
;; actividad nueva. Al final se pone todo en el atributo.

(deffunction anadir-algo (?instancia ?atributo ?actividad)
   (switch ?atributo
      (case manana then  
         (bind ?var (nth$ 1 (send ?instancia get-manana)))
	 (if (eq ?var [nil]) then
	     (send ?instancia put-manana ?actividad)
	  else
             (bind ?var (send ?instancia get-manana))
	     (send ?instancia put-manana (create$ ?var ?actividad))
	 )
      )
      (case tarde then
         (bind ?var (nth$ 1 (send ?instancia get-tarde)))
         (if (eq ?var [nil]) then
             (send ?instancia put-tarde ?actividad)
          else
             (bind ?var (send ?instancia get-tarde))
             (send ?instancia put-tarde (create$ ?var ?actividad))
         )
      )
      (case noche then
         (bind ?var (nth$ 1 (send ?instancia get-noche)))
	 (if (eq ?var [nil]) then
	     (send ?instancia put-noche ?actividad)
	  else
             (bind ?var (send ?instancia get-noche))
	     (send ?instancia put-noche (create$ ?var ?actividad))
	 )	 
      )
   )
)

;; La función comprueba que se puede hacer una actividad en grupo o
;; sólo. Además una persona sola puede hacer una actividad recomendada
;; para un grupo sólo pero un grupo no puede hacer las otras en grupo.

(deffunction grupo (?actividad ?grupo)
      (bind ?var (send ?actividad get-grupo))
      (bind ?respuesta FALSE)
      (switch ?var
          (case s'i then
                (if (eq ?grupo s'i) then (bind ?respuesta TRUE))
           )
          (case no then
                (if (eq ?grupo (or s'i no)) then (bind ?respuesta FALSE))
          )
          (default (bind ?respuesta FALSE))
       )
       (bind ?respuesta ?respuesta)
)

;;; ########################################################################
;;; ### Funciones para distribuir las actividades no comida              ###
;;; ########################################################################

;; La función recibe todas las informaciones de los hechos y una actividad.
;; Después comprueba las condiciones según los parametros ?cond2 ?cond3.
;; Las condiciones son según de nuestra documentación: La segunda es para el 
;; precio y del presupuesto del usuario y la tercera es para el tamaño del
;; grupo y la duración de la activida. (La primera condición es el gusto del
;; usuario.)

;; En la segunda fase de la función buscamos un día de los posibles en que hay 
;; una franja libre en que podemos poner la actividad elegida. Para distribuir
;; las actividades hay dos bucles: un para los días y un para el limite de las
;; actividades en una franja. En el primer paso buscamos una franja libre o de
;; una actividad puesta, después con dos actividades, etc. Sin estos bucles el
;; algoritmo llena el primer día completo y después el próximo.

;; Al final cambiamos el valor del atributo "hecho" para olvidar poner una 
;; misma actividad dos veces en una planificación.

(deffunction distribuir 
   (?actividad ?dia ?precio ?edad_m'axima ?edad_m'inima ?grupo ?duraci'on 
                                                                 ?cond2 ?cond3)

   (if (eq ?cond2 true) then 
       (if (not (< (send ?actividad get-precio) ?precio)) then 
          (return)
       )
   )
   (if (eq ?cond3 true) then 
       (if (not (< (send ?actividad get-duraci'on) ?duraci'on)) then 
            (return)
       )
   )
   (if (eq ?cond3 true) then (if (not (grupo ?actividad ?grupo)) then 
       (return))
   )
   (if (not (>= (send ?actividad get-edad_m'axima) ?edad_m'axima)) then 
       (return)
   )
   (if (not (<= (send ?actividad get-edad_m'inima) ?edad_m'inima)) then 
       (return)
   )

   (bind ?franjas (send ?actividad get-franja))
   (loop-for-count (?i 2 3)
       (loop-for-count (?j 1 ?dia)
           (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario))
             (or
               (and (< (length$ ?horario:manana) ?i) (member$ manana ?franjas))
               (and (< (length$ ?horario:tarde) ?i) (member$ tarde ?franjas))
               (and (< (length$ ?horario:noche) ?i) (member$ noche ?franjas))
             )
           )))
           (if (not (eq ?dia_elegido nil)) then (break))
       )
       (if (not (eq ?dia_elegido nil)) then (break))
   )

   (if (eq ?dia_elegido nil) then (return))   
   
   (bind ?c1 (and 
	       (< (length$ (send ?dia_elegido get-manana)) 3) 
	       (member$ manana ?franjas)
   ))
   (bind ?c2 (and 
	       (< (length$ (send ?dia_elegido get-tarde)) 3) 
	       (member$ tarde ?franjas)
   ))
   (bind ?c3 (and 
	       (< (length$ (send ?dia_elegido get-noche)) 3) 
	       (member$ noche ?franjas)
   ))

   (if ?c1 then
       (anadir-algo ?dia_elegido manana ?actividad)
       (printout t "manana" crlf)
    else
       (if ?c2 then
           (anadir-algo ?dia_elegido tarde ?actividad)
           (printout t "tarde" crlf)
        else
           (if ?c3 then
                (anadir-algo ?dia_elegido noche ?actividad)
                (printout t "noche" crlf)
           )
       )
   )
   (send ?actividad put-hecho s'i)
)

;; Hay sólo una diferencia de esta función y la última: Con la condición 
;; "gusta" podemos buscar una actividad según el nombre de la clase. Por 
;; eso sólo damos el nombre de la clase a la función y elegimos la 
;; actividad dentro. Sin la condición primera no podemos buscar según 
;; del nombre. Ejecutamos al regla/función con cada actividad. Cuando hay 
;; una activida que no cumple todas las condiciones necesarias se acaba 
;; la función.

(deffunction distribuir-gustas 
   (?gusta ?dia ?precio ?edad_m'axima ?edad_m'inima ?grupo 
                                                ?duraci'on ?cond2 ?cond3)
   
   (bind ?limite (+ (* ?dia 0.3) 1))
   (loop-for-count (?i 1 ?limite)
      (bind ?actividad (nth$ 1 (find-instance ((?inst ?gusta))
         (and
            (eq ?inst:hecho no)
            (>= ?inst:edad_m'axima ?edad_m'axima)
            (<= ?inst:edad_m'inima ?edad_m'inima)
         )
      )))
   (if (eq ?actividad nil) then (return))

   (printout t "Actividad: " ?actividad crlf)

   (if (eq ?cond2 true) then 
       (if (not (< (send ?actividad get-precio) ?precio)) then 
          (return)
       )
   )
   (if (eq ?cond3 true) then 
       (if (not (< (send ?actividad get-duraci'on) ?duraci'on)) then 
            (return)
       )
   )
   (if (eq ?cond3 true) then (if (not (grupo ?actividad ?grupo)) then 
       (return))
   )
   (if (not (>= (send ?actividad get-edad_m'axima) ?edad_m'axima)) then 
       (return)
   )
   (if (not (<= (send ?actividad get-edad_m'inima) ?edad_m'inima)) then 
       (return)
   )
   
   (bind ?franjas (send ?actividad get-franja))
     (loop-for-count (?i 2 3)
       (loop-for-count (?j 1 ?dia)
         (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario))
            (or
              (and (< (length$ ?horario:manana) ?i) (member$ manana ?franjas))
              (and (< (length$ ?horario:tarde) ?i) (member$ tarde ?franjas))
              (and (< (length$ ?horario:noche) ?i) (member$ noche ?franjas))
            )
          )))
          (if (not (eq ?dia_elegido nil)) then (break))
	)      
        (if (not (eq ?dia_elegido nil)) then (break))
      )

      (if (eq ?dia_elegido nil) then (return))

      (bind ?c1 (and 
		    (< (length$ (send ?dia_elegido get-manana)) 3) 
		    (member$ manana ?franjas)
      ))
      (bind ?c2 (and 
		    (< (length$ (send ?dia_elegido get-tarde)) 3) 
		    (member$ tarde ?franjas)
      ))
      (bind ?c3 (and 
		    (< (length$ (send ?dia_elegido get-noche)) 3) 
		    (member$ noche ?franjas)
      ))

      (if ?c1 then
           (anadir-algo ?dia_elegido manana ?actividad)
       else
           (if ?c2 then
                 (anadir-algo ?dia_elegido tarde ?actividad)
            else
                 (if ?c3 then
                      (anadir-algo ?dia_elegido noche ?actividad)
                 )
            )
       )
       (send ?actividad put-hecho s'i)
   )
) 

;; La función para distribuir las actividades obligatorias es más 
;; sencilla porque no hace falta comprobar las condiciones. El 
;; usuario quiere hacerlo independiente de otras condiciones.

(deffunction distribuir-obligatorias (?gusta)

   (bind ?actividad 
         (nth$ 1 (find-instance ((?inst ?gusta)) (eq ?inst:hecho no)))
   )
   (if (eq ?actividad nil) then (return))
   
   (bind ?franjas (send ?actividad get-franja))

   (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario)) (or 
      (and (eq (nth$ 1 ?horario:manana) [nil]) (member$ manana ?franjas))
      (and (eq (nth$ 1 ?horario:tarde) [nil]) (member$ tarde ?franjas))
      (and (eq (nth$ 1 ?horario:noche) [nil]) (member$ noche ?franjas))))))

   (bind ?c1 
        (and 
	   (eq (nth$ 1 (send ?dia_elegido get-manana)) [nil]) 
	   (member$ manana ?franjas)
   ))
   (bind ?c2 
        (and 
	   (eq (nth$ 1 (send ?dia_elegido get-tarde)) [nil]) 
	   (member$ tarde ?franjas) 
   ))
   (bind ?c3 
        (and 
	   (eq (nth$ 1 (send ?dia_elegido get-noche)) [nil]) 
	   (member$ noche ?franjas)
   ))


   (if ?c1 then 
        (send ?dia_elegido put-manana ?actividad)
    else
        (if ?c2 then 
            (send ?dia_elegido put-tarde ?actividad)
         else
            (if ?c3 then
                (send ?dia_elegido put-noche ?actividad)
            )
        )
   ) 
)

;;; ########################################################################
;;; ### Funciones para distribuir las actividades de comida              ###
;;; ########################################################################

;; Las funciones de la distribución de las actividades de comida son muy
;; parecidos, hay sólo una diferencia: El atributo de la comida en el horario
;; sólo permite una actividad, por eso na hacen falta las bucles y las
;; funciones especiales para añadir una actividad. Pero el principio es lo
;; mismo.

(deffunction distribuir-comida 
   (?actividad ?dia ?precio ?edad_m'axima ?edad_m'inima ?grupo 
                                                      ?duraci'on ?cond2 ?cond3)

   (if (eq ?cond2 true) then 
       (if (not (< (send ?actividad get-precio) ?precio)) then 
          (return)
       )
   )
   (if (eq ?cond3 true) then 
       (if (not (< (send ?actividad get-duraci'on) ?duraci'on)) then 
            (return)
       )
   )
   (if (eq ?cond3 true) then (if (not (grupo ?actividad ?grupo)) then 
       (return))
   )
   (if (not (>= (send ?actividad get-edad_m'axima) ?edad_m'axima)) then 
       (return)
   )
   (if (not (<= (send ?actividad get-edad_m'inima) ?edad_m'inima)) then 
       (return)
   )

   (loop-for-count (?j 1 ?dia)
       (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario))
           (or
              (eq ?horario:comida_primera [nil])
              (eq ?horario:comida_segunda [nil])
           )
       )))
       (if (not (eq ?dia_elegido nil)) then (break))
   )
 
   (if (eq ?dia_elegido nil) then (return))   
   
   (bind ?c1 (eq (send ?dia_elegido get-comida_primera) [nil]) )
   (bind ?c2 (eq (send ?dia_elegido get-comida_segunda) [nil]) )

   (if ?c1 then
       (send ?dia_elegido put-comida_primera ?actividad)
    else
       (if ?c2 then
           (send ?dia_elegido put-comida_segunda ?actividad)
       )
   )
   (send ?actividad put-hecho s'i)
)

(deffunction distribuir-comida-gustas 
   (?gusta ?dia ?precio ?edad_m'axima ?edad_m'inima ?grupo 
                                                    ?duraci'on ?cond2 ?cond3)
   
   (bind ?limite (+ (* ?dia 0.3) 1))
   (loop-for-count (?i 1 ?limite)
      (bind ?actividad (nth$ 1 (find-instance ((?inst ?gusta))
         (and
            (eq ?inst:hecho no)
            (>= ?inst:edad_m'axima ?edad_m'axima)
            (<= ?inst:edad_m'inima ?edad_m'inima)
         )
      )))
   )
   (if (eq ?actividad nil) then (return))

   (if (eq ?cond2 true) then 
       (if (not (< (send ?actividad get-precio) ?precio)) then 
          (return)
       )
   )
   (if (eq ?cond3 true) then 
       (if (not (< (send ?actividad get-duraci'on) ?duraci'on)) then 
            (return)
       )
   )
   (if (eq ?cond3 true) then (if (not (grupo ?actividad ?grupo)) then 
	(return))
   )
   (if (not (>= (send ?actividad get-edad_m'axima) ?edad_m'axima)) then 
        (return)
   )
   (if (not (<= (send ?actividad get-edad_m'inima) ?edad_m'inima)) then 
        (return)
   )
   
   (loop-for-count (?j 1 ?dia)
       (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario))
           (or
              (eq ?horario:comida_primera [nil])
              (eq ?horario:comida_segunda [nil])
           )
       )))
       (if (not (eq ?dia_elegido nil)) then (break))
   )

   (if (eq ?dia_elegido nil) then (return))

   (bind ?c1 (eq (send ?dia_elegido get-comida_primera) [nil]))
   (bind ?c2 (eq (send ?dia_elegido get-comida_segunda) [nil]))

   (if ?c1 then
      (send ?dia_elegido put-comida_primera ?actividad)
    else
      (if ?c2 then
           (send ?dia_elegido put-comida_segunda ?actividad)
      )
    )
    (send ?actividad put-hecho s'i)
) 


(deffunction distribuir-comida-obligatorias (?gusta)

   (bind ?actividad 
         (nth$ 1 (find-instance ((?inst ?gusta)) (eq ?inst:hecho no)))
   )

   (bind ?dia_elegido (nth$ 1 (find-instance ((?horario Horario)) 
      (or 
         (eq (nth$ 1 ?horario:comida_primera) [nil])
         (eq (nth$ 1 ?horario:comida_segunda) [nil])
      )
   )))

   (bind ?c1 (eq (nth$ 1 (send ?dia_elegido get-comida_primera)) [nil]))
   (bind ?c2 (eq (nth$ 1 (send ?dia_elegido get-comida_segunda)) [nil]))

   (if ?c1 then 
        (send ?dia_elegido put-comida_primera ?actividad)
    else
        (if ?c2 then 
            (send ?dia_elegido put-comida_segunda ?actividad)
        )
   ) 
   (send ?actividad put-hecho s'i)
)

;;; ########################################################################
;;; ### Reglas para las actividades no comida                            ###
;;; ########################################################################

;; En el inicio todas las actividades prohibidas reciben el valor "sí" para 
;; el atributo "hecho". Después no son disponibles para la planificación

(defrule prohibidas
   (declare (salience -1))
   (prohibido ?prohibido)
=> 
   (do-for-all-instances ((?inst ?prohibido)) TRUE
       (send ?inst put-hecho s'i)
   )
)

;; Lss reglas son para cada combinación de las condiciones. Por ejemplo la
;; parte final del nombre de una regla ".2." significa que una actividad
;; debe cumplir la condición 2.

(defrule distribuir-obligatorias 
   (declare (salience -1))
   (obligatorio ?nombre)
=>
   (distribuir-obligatorias ?nombre)
)


(defrule distribuir-perfectas
   (declare (salience -2))
   (d'ia ?d)
   (gusta ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=> 
   (distribuir-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur true true)
)

(defrule distribuir-obligatorias 
   (declare (salience -3))
   (obligatorio ?nombre)
=>
   (distribuir-obligatorias ?nombre)
)

(defrule distribuir-12.
   (declare (salience -4))
   (d'ia ?d)
   (gusta ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
   =>
   (distribuir-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur true false)
)  

(defrule distribuir-1..
   (declare (salience -5))
   (d'ia ?d)
   (gusta ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur false false)
)    

(defrule distribuir-.23
   (declare (salience -6))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_no_comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir ?actividad ?d ?p ?emax ?emin ?g ?dur true true)
)
 
(defrule distribuir-.2.
   (declare (salience -7))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_no_comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir ?actividad ?d ?p ?emax ?emin ?g ?dur true false)
)    

(defrule distribuir-..3
   (declare (salience -8))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_no_comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir ?actividad ?d ?p ?emax ?emin ?g ?dur false true)
)

(defrule distribuir-...
   (declare (salience -9))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_no_comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir ?actividad ?d ?p ?emax ?emin ?g ?dur false false)
)

;;; ########################################################################
;;; ### Reglas para las actividades de comida                            ###
;;; ########################################################################

;; Las reglas con del mismo orden como las actividades no comida y con el
;; mismo principio.

(defrule comida-prohibidas
   (declare (salience -1))
   (prohibido comida ?prohibido)
=> 
   (do-for-all-instances ((?inst ?prohibido)) TRUE
       (send ?inst put-hecho s'i)
   )
)


(defrule distribuir-comida-obligatorias 
   (declare (salience -1))
   (obligatorio comida ?nombre)
=>
   (distribuir-comida-obligatorias ?nombre)
)


(defrule distribuir-comida-perfectas
   (declare (salience -2))
   (d'ia ?d)
   (gusta comida ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=> 
   (distribuir-comida-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur true true)
)

(defrule distribuir-comida-obligatorias 
   (declare (salience -3))
   (obligatorio comida ?nombre)
=>
   (distribuir-comida-obligatorias ?nombre)
)

(defrule distribuir-comida-12.
   (declare (salience -4))
   (d'ia ?d)
   (gusta comida ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
   =>
   (distribuir-comida-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur true false)
)  

(defrule distribuir-comida-1..
   (declare (salience -5))
   (d'ia ?d)
   (gusta comida ?nombre)
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-comida-gustas ?nombre ?d ?p ?emax ?emin ?g ?dur false false)
)    

(defrule distribuir-comida-.23
   (declare (salience -6))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_Comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-comida ?actividad ?d ?p ?emax ?emin ?g ?dur true true)
)
 
(defrule distribuir-comida-.2.
   (declare (salience -7))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_Comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-comida ?actividad ?d ?p ?emax ?emin ?g ?dur true false)
)    

(defrule distribuir-comida-..3
   (declare (salience -8))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_Comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-comida ?actividad ?d ?p ?emax ?emin ?g ?dur false true)
)

(defrule distribuir-comida-...
   (declare (salience -9))
   (d'ia ?d)
   ?actividad <- (object (is-a Actividad_Comida))
   (edad_m'axima ?emax)
   (edad_m'inima ?emin)
   (duraci'on ?dur)
   (precio_m'aximo ?p)
   (grupo ?g)
=>
   (distribuir-comida ?actividad ?d ?p ?emax ?emin ?g ?dur false false)
)
